OpenAPI SpecificationJSON
API Reference

Email Thread

An email thread object represents thread of related objects in Rossum's inbox.

Email thread

Attribute
Type
Description
id*
read-only
integer

ID of the email thread.

url*
URL

URL of the email thread.

organization*
URL

Organization URL.

queue*
URL

Queue URL.

root_email*
read-only
URL

URL of the associated root email (first incoming email in the thread).

has_replies*
read-only
boolean

True if the thread has more than one incoming emails.

has_new_replies*
boolean

True if the thread has unread incoming emails.

root_email_read*
read-only
boolean

True if the root email has been opened in Rossum UI at least once.

created_at*
read-only
datetime

Timestamp of the creation of email thread (inherited from arrived_at timestamp of the root email).

last_email_created_at*
read-only
datetime

Timestamp of the most recent email in this email thread.

subject*
read-only
string

Subject of the root email.

from*
read-only
object

Information about sender of the root email containing keys email and name.

email
string (email)

Email address of the sender.

name
string

Name of the sender.

labels*
read-only
list[string]

This attribute is intended for INTERNAL use only and may be changed without notice. List of email thread labels set by root email. If root email is rejected and no other incoming emails are in thread, labels field is set to [rejected]. Labels is an empty list in all the other cases.

annotation_counts*
read-only
object

This attribute is intended for INTERNAL use only and may be changed without notice. Information about how many annotations were extracted from all emails in the thread and in which state they currently are.

annotations
integer

Total number of annotations.

annotations_processed
integer

Number of processed annotations.

annotations_purged
integer

Number of purged annotations.

annotations_rejected
integer

Number of rejected annotations.

annotations_unprocessed
integer

Number of not yet processed annotations.

List email threads

GET api / v1 / email_threads

Retrieve all email thread objects.

GET
/api/v1/email_threads
curl -X GET "https://example.rossum.app/api/v1/email_threads"
{
  "pagination": {
    "next": null,
    "previous": null
  },
  "results": [
    {
      "id": 1244,
      "url": "https://example.rossum.app/api/v1/email_threads/456",
      "organization": "string",
      "queue": "https://example.rossum.app/api/v1/queues/8198",
      "root_email": "https://example.rossum.app/api/v1/emails/1234",
      "has_replies": false,
      "has_new_replies": false,
      "root_email_read": false,
      "created_at": "2021-06-10T12:38:44.866180Z",
      "last_email_created_at": "2021-11-01T18:02:24.740600Z",
      "subject": "Root email subject",
      "from": {
        "email": "satisfied.customer@rossum.ai",
        "name": "Satisfied Customer"
      },
      "labels": [],
      "annotation_counts": {
        "annotations": 4,
        "annotations_processed": 2,
        "annotations_purged": 0,
        "annotations_rejected": 1,
        "annotations_unprocessed": 1
      }
    }
  ]
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Response

200OK

OK

Attribute
Type
Description
pagination*
pagination
next
URL

URL for the next page of results. Contains an opaque signed cursor query parameter. Use this URL directly to fetch the next page — do not attempt to construct or modify the cursor value.

previous
URL

URL for the previous page of results. Contains an opaque signed cursor query parameter. Use this URL directly to fetch the previous page — do not attempt to construct or modify the cursor value.

results*
id*
read-only
integer

ID of the email thread.

url*
URL

URL of the email thread.

organization*
URL

Organization URL.

queue*
URL

Queue URL.

root_email*
read-only
URL

URL of the associated root email (first incoming email in the thread).

has_replies*
read-only
boolean

True if the thread has more than one incoming emails.

has_new_replies*
boolean

True if the thread has unread incoming emails.

root_email_read*
read-only
boolean

True if the root email has been opened in Rossum UI at least once.

created_at*
read-only
datetime

Timestamp of the creation of email thread (inherited from arrived_at timestamp of the root email).

last_email_created_at*
read-only
datetime

Timestamp of the most recent email in this email thread.

subject*
read-only
string

Subject of the root email.

from*
read-only
object

Information about sender of the root email containing keys email and name.

email
string (email)

Email address of the sender.

name
string

Name of the sender.

labels*
read-only
list[string]

This attribute is intended for INTERNAL use only and may be changed without notice. List of email thread labels set by root email. If root email is rejected and no other incoming emails are in thread, labels field is set to [rejected]. Labels is an empty list in all the other cases.

annotation_counts*
read-only
object

This attribute is intended for INTERNAL use only and may be changed without notice. Information about how many annotations were extracted from all emails in the thread and in which state they currently are.

annotations
integer

Total number of annotations.

annotations_processed
integer

Number of processed annotations.

annotations_purged
integer

Number of purged annotations.

annotations_rejected
integer

Number of rejected annotations.

annotations_unprocessed
integer

Number of not yet processed annotations.

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

Retrieve email thread

GET api / v1 / email_threads / {emailThreadID}

Get an email thread object.

GET
/api/v1/email_threads/{emailThreadID}
curl -X GET "https://example.rossum.app/api/v1/email_threads/0"
{
  "id": 1244,
  "url": "https://example.rossum.app/api/v1/email_threads/456",
  "organization": "string",
  "queue": "https://example.rossum.app/api/v1/queues/8198",
  "root_email": "https://example.rossum.app/api/v1/emails/1234",
  "has_replies": false,
  "has_new_replies": false,
  "root_email_read": false,
  "created_at": "2021-06-10T12:38:44.866180Z",
  "last_email_created_at": "2021-11-01T18:02:24.740600Z",
  "subject": "Root email subject",
  "from": {
    "email": "satisfied.customer@rossum.ai",
    "name": "Satisfied Customer"
  },
  "labels": [],
  "annotation_counts": {
    "annotations": 4,
    "annotations_processed": 2,
    "annotations_purged": 0,
    "annotations_rejected": 1,
    "annotations_unprocessed": 1
  }
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Response

200OK

OK

Attribute
Type
Description
id*
read-only
integer

ID of the email thread.

url*
URL

URL of the email thread.

organization*
URL

Organization URL.

queue*
URL

Queue URL.

root_email*
read-only
URL

URL of the associated root email (first incoming email in the thread).

has_replies*
read-only
boolean

True if the thread has more than one incoming emails.

has_new_replies*
boolean

True if the thread has unread incoming emails.

root_email_read*
read-only
boolean

True if the root email has been opened in Rossum UI at least once.

created_at*
read-only
datetime

Timestamp of the creation of email thread (inherited from arrived_at timestamp of the root email).

last_email_created_at*
read-only
datetime

Timestamp of the most recent email in this email thread.

subject*
read-only
string

Subject of the root email.

from*
read-only
object

Information about sender of the root email containing keys email and name.

email
string (email)

Email address of the sender.

name
string

Name of the sender.

labels*
read-only
list[string]

This attribute is intended for INTERNAL use only and may be changed without notice. List of email thread labels set by root email. If root email is rejected and no other incoming emails are in thread, labels field is set to [rejected]. Labels is an empty list in all the other cases.

annotation_counts*
read-only
object

This attribute is intended for INTERNAL use only and may be changed without notice. Information about how many annotations were extracted from all emails in the thread and in which state they currently are.

annotations
integer

Total number of annotations.

annotations_processed
integer

Number of processed annotations.

annotations_purged
integer

Number of purged annotations.

annotations_rejected
integer

Number of rejected annotations.

annotations_unprocessed
integer

Number of not yet processed annotations.

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

Partial update email thread

PATCH api / v1 / email_threads / {emailThreadID}

Update part of email thread object.

PATCH
/api/v1/email_threads/{emailThreadID}
curl -X PATCH "https://example.rossum.app/api/v1/email_threads/0" \  -H "Content-Type: application/json" \  -d '{}'
{
  "id": 1244,
  "url": "https://example.rossum.app/api/v1/email_threads/456",
  "organization": "string",
  "queue": "https://example.rossum.app/api/v1/queues/8198",
  "root_email": "https://example.rossum.app/api/v1/emails/1234",
  "has_replies": false,
  "has_new_replies": false,
  "root_email_read": false,
  "created_at": "2021-06-10T12:38:44.866180Z",
  "last_email_created_at": "2021-11-01T18:02:24.740600Z",
  "subject": "Root email subject",
  "from": {
    "email": "satisfied.customer@rossum.ai",
    "name": "Satisfied Customer"
  },
  "labels": [],
  "annotation_counts": {
    "annotations": 4,
    "annotations_processed": 2,
    "annotations_purged": 0,
    "annotations_rejected": 1,
    "annotations_unprocessed": 1
  }
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Payload Too Large.",
  "code": "payload_too_large"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Request Body

application/json

Attribute
Type
Description
url
URL

URL of the email thread.

organization
URL

Organization URL.

queue
URL

Queue URL.

has_new_replies
boolean

True if the thread has unread incoming emails.

Response

200OK

OK

Attribute
Type
Description
id*
read-only
integer

ID of the email thread.

url*
URL

URL of the email thread.

organization*
URL

Organization URL.

queue*
URL

Queue URL.

root_email*
read-only
URL

URL of the associated root email (first incoming email in the thread).

has_replies*
read-only
boolean

True if the thread has more than one incoming emails.

has_new_replies*
boolean

True if the thread has unread incoming emails.

root_email_read*
read-only
boolean

True if the root email has been opened in Rossum UI at least once.

created_at*
read-only
datetime

Timestamp of the creation of email thread (inherited from arrived_at timestamp of the root email).

last_email_created_at*
read-only
datetime

Timestamp of the most recent email in this email thread.

subject*
read-only
string

Subject of the root email.

from*
read-only
object

Information about sender of the root email containing keys email and name.

email
string (email)

Email address of the sender.

name
string

Name of the sender.

labels*
read-only
list[string]

This attribute is intended for INTERNAL use only and may be changed without notice. List of email thread labels set by root email. If root email is rejected and no other incoming emails are in thread, labels field is set to [rejected]. Labels is an empty list in all the other cases.

annotation_counts*
read-only
object

This attribute is intended for INTERNAL use only and may be changed without notice. Information about how many annotations were extracted from all emails in the thread and in which state they currently are.

annotations
integer

Total number of annotations.

annotations_processed
integer

Number of processed annotations.

annotations_purged
integer

Number of purged annotations.

annotations_rejected
integer

Number of rejected annotations.

annotations_unprocessed
integer

Number of not yet processed annotations.

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

413

Payload too large (especially for files uploaded).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

Update email thread

PUT api / v1 / email_threads / {emailThreadID}

Update email thread object.

PUT
/api/v1/email_threads/{emailThreadID}
curl -X PUT "https://example.rossum.app/api/v1/email_threads/0" \  -H "Content-Type: application/json" \  -d '{    "has_new_replies": false  }'
{
  "id": 1244,
  "url": "https://example.rossum.app/api/v1/email_threads/456",
  "organization": "string",
  "queue": "https://example.rossum.app/api/v1/queues/8198",
  "root_email": "https://example.rossum.app/api/v1/emails/1234",
  "has_replies": false,
  "has_new_replies": false,
  "root_email_read": false,
  "created_at": "2021-06-10T12:38:44.866180Z",
  "last_email_created_at": "2021-11-01T18:02:24.740600Z",
  "subject": "Root email subject",
  "from": {
    "email": "satisfied.customer@rossum.ai",
    "name": "Satisfied Customer"
  },
  "labels": [],
  "annotation_counts": {
    "annotations": 4,
    "annotations_processed": 2,
    "annotations_purged": 0,
    "annotations_rejected": 1,
    "annotations_unprocessed": 1
  }
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Payload Too Large.",
  "code": "payload_too_large"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Request Body

application/json

Attribute
Type
Description
url
URL

URL of the email thread.

organization
URL

Organization URL.

queue
URL

Queue URL.

has_new_replies*
boolean

True if the thread has unread incoming emails.

Response

200OK

OK

Attribute
Type
Description
id*
read-only
integer

ID of the email thread.

url*
URL

URL of the email thread.

organization*
URL

Organization URL.

queue*
URL

Queue URL.

root_email*
read-only
URL

URL of the associated root email (first incoming email in the thread).

has_replies*
read-only
boolean

True if the thread has more than one incoming emails.

has_new_replies*
boolean

True if the thread has unread incoming emails.

root_email_read*
read-only
boolean

True if the root email has been opened in Rossum UI at least once.

created_at*
read-only
datetime

Timestamp of the creation of email thread (inherited from arrived_at timestamp of the root email).

last_email_created_at*
read-only
datetime

Timestamp of the most recent email in this email thread.

subject*
read-only
string

Subject of the root email.

from*
read-only
object

Information about sender of the root email containing keys email and name.

email
string (email)

Email address of the sender.

name
string

Name of the sender.

labels*
read-only
list[string]

This attribute is intended for INTERNAL use only and may be changed without notice. List of email thread labels set by root email. If root email is rejected and no other incoming emails are in thread, labels field is set to [rejected]. Labels is an empty list in all the other cases.

annotation_counts*
read-only
object

This attribute is intended for INTERNAL use only and may be changed without notice. Information about how many annotations were extracted from all emails in the thread and in which state they currently are.

annotations
integer

Total number of annotations.

annotations_processed
integer

Number of processed annotations.

annotations_purged
integer

Number of purged annotations.

annotations_rejected
integer

Number of rejected annotations.

annotations_unprocessed
integer

Number of not yet processed annotations.

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

413

Payload too large (especially for files uploaded).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error